package org.s4s.gui;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.Title;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.navigator.Navigator;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.*;
import javax.servlet.annotation.WebServlet;
import org.s4s.gui.views.*;
import org.s4s.services.util.Views;

/**
 * This UI is the application entry point. A UI may either represent a browser
 * window (or tab) or some part of a html page where a Vaadin application is
 * embedded.
 * <p>
 * The UI is initialized using {@link #init(VaadinRequest)}. This method is
 * intended to be overridden to add component to the user interface and
 * initialize non-component functionality.
 */
@Theme("mytheme")
@Title("Shop in Shop")
public class InitView extends UI {

    @Override
    protected void init(VaadinRequest vaadinRequest) {
        Navigator navi = new Navigator(this, this);
        navi.addView(Views.SUCHE, SucheView.class);
        navi.addView(Views.WELCOME, WelcomeView.class);
        navi.addView(Views.LOGIN, LoginView.class);
        navi.addView(Views.WARENKORB, WarenkorbView.class);
        navi.addView(Views.PASSWORT, PasswortView.class);
        navi.addView(Views.BENUTZERKONTO, BenutzerkontoView.class);
        navi.addView(Views.ARTIKELDETAILS, ArtikeldetailsView.class);
        navi.addView(Views.CHECKOUT, CheckoutView.class);
        navi.addView(Views.IMPRESSUM, ImpressumView.class);
        navi.addView(Views.FAQ, FaqView.class);
        navi.addView(Views.KAUFBESTAETIGUNG, KaufbestaetigungView.class);
        navi.addView(Views.VERKAEUFERBEWERTUNG, VerkaeuferbewertungView.class);
        navi.addView(Views.CONTACT, ContactView.class);
        navi.addView(Views.REGISTRIERUNG, RegistrierungView.class);
        navi.addView(Views.SHOPERSTELLUNG, ShopErstellung.class);
        navi.addView(Views.SHOPERSTELLUNGSBESTAETIGUNG, ShoperstellungsBestätigung.class);
        navi.addView(Views.REGISTRIERUNGSBESTAETIGUNG, RegistrierungsBestaetigung.class);
        navi.addView(Views.KONTAKTBESTAETIGUNG, Kontaktbestaetigung.class);
        navi.addView(Views.TRANSAKTIONSBESTAETIGUNG, TransaktionsBestaetigung.class);
        //Test der RegistrierungsView
        UI.getCurrent().getNavigator().navigateTo(Views.WELCOME);
        setHeight(100f, Unit.PERCENTAGE);
        setWidth(100f, Unit.PERCENTAGE);

        //UI.getCurrent().getNavigator().navigateTo(Views.REGISTRIERUNG);
        //this.setWidth(64f, Unit.PERCENTAGE);
    }

    @WebServlet(urlPatterns = "/*", name = "MyUIServlet", asyncSupported = true)
    @VaadinServletConfiguration(ui = InitView.class, productionMode = false)
    public static class MyUIServlet extends VaadinServlet {
    }
}
