package org.s4s.gui.views;

import com.vaadin.navigator.View;
import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.server.FontAwesome;
import com.vaadin.shared.ui.label.ContentMode;
import com.vaadin.ui.Button;
import com.vaadin.ui.FormLayout;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Panel;
import com.vaadin.ui.TextField;
import com.vaadin.ui.UI;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.s4s.exceptions.OwnsAlreadyShop;
import org.s4s.process.control.ShopControl;
import org.s4s.services.util.Roles;
import org.s4s.services.util.Views;

/**
 *
 * @author JanPhilipp
 */
public class ShopErstellung extends TemplateView implements View {

    private String s = null;

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        if (session.getAttribute(Roles.CURRENTUSER) == null) {
            UI.getCurrent().getNavigator().navigateTo(Views.LOGIN);
            Notification.show(null, "Einloggen, um einen Shop erstellen zu können!", Notification.Type.WARNING_MESSAGE);
        }
        this.setUp();
    }

    private void setUp() {
        Panel panel = new Panel("ShopErstellung");
        panel.setSizeUndefined();

        FormLayout content = new FormLayout();

//                TextField shopowner = new TextField("Name des Shoperstellers");
//                content.addComponent(shopowner);
        TextField shopname = new TextField("Name des Shops");
        content.addComponent(shopname);

//                NativeSelect select = new NativeSelect("Position an der Hochschule");
//                select.addItems("Student", "Hivi", "Prof");
//                select.setNullSelectionAllowed(false);
//                content.addComponent(select);
//        TextArea area = new TextArea("Shopbeschreibung");
//        content.addComponent(area);
//                TextField emailTxt = new TextField("E-Mail:");
//                emailTxt.setIcon(FontAwesome.MAIL_FORWARD);
//                content.addComponent(emailTxt);
        HorizontalLayout buttons = new HorizontalLayout();
        Button abbruch = new Button("Abbruch");
        abbruch.setIcon(FontAwesome.STOP_CIRCLE);
        buttons.addComponent(abbruch);
        buttons.addComponent(new Label("&nbsp", ContentMode.HTML));
        Button bestätigen = new Button("Bestätigen");
        bestätigen.setIcon(FontAwesome.CHECK);
        buttons.addComponent(bestätigen);

        content.addComponent(buttons);
        content.setMargin(true);

        panel.setContent(content);
        //this.addComponent(panel);
        //this.setComponentAlignment(panel, Alignment.MIDDLE_CENTER);

        bestätigen.addClickListener(e -> {
//             String shopOwner = shopowner.getValue();
//             String email = emailTxt.getValue();
            String shopName = shopname.getValue();
            //           String beschreibung = area.getValue();
            try {
                ShopControl.checkUserShop(shopName);
            } catch (OwnsAlreadyShop ex) {
                Logger.getLogger(ShopErstellung.class.getName()).log(Level.SEVERE, null, ex);
            } catch (SQLException ex) {
                Logger.getLogger(ShopErstellung.class.getName()).log(Level.SEVERE, null, ex);
            }
            UI.getCurrent().getNavigator().navigateTo(Views.SHOPERSTELLUNGSBESTAETIGUNG);
            //   select.addValueChangeListener(event ->);

//             System.out.println(shopOwner);
            System.out.println(shopname);
//             System.out.println(email);
//            System.out.println(beschreibung);
            System.out.println(s);

            // Weiterleitung auf Bestätigunsseite
        });
        abbruch.addClickListener(e -> {
            UI.getCurrent().getNavigator().navigateTo(Views.WELCOME);
        });

        super.setUpFooterAndHeader(panel);
    }
}
