package org.s4s.gui.views;

import com.vaadin.navigator.View;
import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.server.*;
import com.vaadin.ui.*;
import com.vaadin.ui.themes.BaseTheme;
import java.io.File;
import org.s4s.process.control.LogoutControl;
import org.s4s.process.control.ProductSearch;
import org.s4s.services.util.Roles;
import org.s4s.services.util.Views;

/**
 * Created by Max-Desktop on 14.05.2017.
 */
public class TemplateView extends VerticalLayout implements View {

    VaadinSession session = UI.getCurrent().getSession();
    ProductSearch search = ProductSearch.getInstance();

    private Image createLogo() {
        HorizontalLayout logoLayout = new HorizontalLayout();
        logoLayout.addStyleName("logoLayout");

        String rootpath = VaadinService.getCurrent().getBaseDirectory().getAbsolutePath();

        FileResource srcLogo = new FileResource(new File(rootpath + "/WEB-INF/images/logo4.jpeg"));

        Image logo = new Image();

        logo.setSource(srcLogo);
        logo.setStyleName("logo");
        return logo;
    }

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent viewChangeEvent) {

    }

    public void setLoginButton() {

    }

    public void setUpFooterAndHeader(AbstractComponent content) {
        //HEADER

        final GridLayout headerLayout = new GridLayout(3, 1);
        //@Max: Logo eingefügt, brauchen wir meiner Meinung nach nicht mehr. #svolle2s
        headerLayout.setSpacing(true);
        // refactored Code --> header and Footer are outsourced by there own methodes #mkomp2s
        HorizontalLayout navigationPanelGrid = buildNavigationHeader();
        HorizontalLayout footerLayout = buildFooter();

        content.addStyleName("MainContenLocation");

        //Final Content warpping Header and Footer around Content #mkomp2s
        final VerticalLayout mainLayout = new VerticalLayout(headerLayout, navigationPanelGrid, content, footerLayout);
        mainLayout.setSizeFull();
        ///mainLayout.setExpandRatio(content,  1);
        mainLayout.setSpacing(true);;
        mainLayout.setComponentAlignment(footerLayout, Alignment.BOTTOM_CENTER);

        addComponent(mainLayout);

        mainLayout.setWidthUndefined();
        //setComponentAlignment(navigationPanelGrid,Alignment.MIDDLE_CENTER);
        setComponentAlignment(mainLayout, Alignment.MIDDLE_CENTER);

        this.setSpacing(true);
        this.setHeightUndefined();
        this.setWidthUndefined();
        this.setMargin(true);
    }

    HorizontalLayout buildNavigationHeader() {
        HorizontalLayout navigationPanelGrid = new HorizontalLayout();
        MenuBar.Command mycommand = new MenuBar.Command() {
            @Override
            public void menuSelected(MenuBar.MenuItem selectedItem) {
                System.out.println(selectedItem);

                switch (selectedItem.getText()) {
                    case "Home":
                        UI.getCurrent().getNavigator().navigateTo(Views.WELCOME);
                        break;

                    case "Warenkorb":
                        UI.getCurrent().getNavigator().navigateTo(Views.WARENKORB);
                        break;

                    case "Kasse":
                        UI.getCurrent().getNavigator().navigateTo(Views.CHECKOUT);
                        break;
                    case "Login":
                        UI.getCurrent().getNavigator().navigateTo(Views.LOGIN);
                        break;
                    case "Registrieren":
                        UI.getCurrent().getNavigator().navigateTo(Views.REGISTRIERUNG);
                        break;
                    case "Einstellungen":
                        UI.getCurrent().getNavigator().navigateTo(Views.BENUTZERKONTO);
                        break;
                    case "Logout":
                        LogoutControl.logout();
                        UI.getCurrent().getNavigator().navigateTo(Views.WELCOME);
                        break;
                    case "Kontakt":
                        UI.getCurrent().getNavigator().navigateTo(Views.CONTACT);
                        break;

                    // Edit Holger Anfang
                    case "Literatur":
                        UI.getCurrent().getNavigator().navigateTo(Views.SUCHE + "/literatur");
                        break;

                    case "Mitschriften":
                        UI.getCurrent().getNavigator().navigateTo(Views.SUCHE + "/mitschriften");
                        break;

                    case "Nachhilfe":
                        UI.getCurrent().getNavigator().navigateTo(Views.SUCHE + "/nachhilfe");
                        break;
                    // Edit Ende

                }
            }
        ;
        };
        MenuBar barmenu = new MenuBar();
        MenuBar.MenuItem homeItem = barmenu.addItem("Home", null, mycommand);

// Another top-level item
        MenuBar.MenuItem categoryItem = barmenu.addItem("Kategorien", null, null);
        categoryItem.addItem("Literatur", null, mycommand);
        categoryItem.addItem("Mitschriften", null, mycommand);
        categoryItem.addItem("Nachhilfe", null, mycommand);

// Yet another top-level item
        MenuBar.MenuItem shoppingCardItem = barmenu.addItem("Warenkorb", null, mycommand);
        MenuBar.MenuItem checktoutItem = barmenu.addItem("Kasse", null, mycommand);
        MenuBar.MenuItem loginItem = barmenu.addItem("Login", null, mycommand);
        MenuBar.MenuItem registerItem = barmenu.addItem("Registrieren", null, mycommand);

        MenuBar.MenuItem userItem = barmenu.addItem("Mein Konto", null, null);

        userItem.addItem("Einstellungen", null, mycommand);
        userItem.addItem("Logout", null, mycommand);

        TextField tfSearch = new TextField();
        Button btnSearch = new Button("Suche", FontAwesome.SEARCH);

        //Edit Holger
        btnSearch.addClickListener((Button.ClickEvent event) -> {
            String begriff = tfSearch.getValue();
            View view = UI.getCurrent().getNavigator().getCurrentView();
            //if (view instanceof SucheView) {

            //} else {
            UI.getCurrent().getNavigator().navigateTo(Views.SUCHE + "/" + begriff);
            //}
        });
        //Edit Ende
        navigationPanelGrid.addComponent(createLogo());
        navigationPanelGrid.addComponent(barmenu);
        navigationPanelGrid.addComponent(tfSearch);
        navigationPanelGrid.addComponent(btnSearch);
        navigationPanelGrid.setSpacing(true);
        navigationPanelGrid.setSizeUndefined();
        if (session.getAttribute(Roles.CURRENTUSER) == null) {
            userItem.setVisible(false);
        } else {
            registerItem.setVisible(false);
            loginItem.setVisible(false);
        }
        navigationPanelGrid.setStyleName("navbarGardient");
        navigationPanelGrid.setComponentAlignment(barmenu, Alignment.MIDDLE_CENTER);
        navigationPanelGrid.setComponentAlignment(tfSearch, Alignment.MIDDLE_RIGHT);
        navigationPanelGrid.setComponentAlignment(btnSearch, Alignment.MIDDLE_RIGHT);

        return navigationPanelGrid;
    }

    HorizontalLayout buildFooter() {

        //FOOTER
        HorizontalLayout footerLayout = new HorizontalLayout();
        Button btnImpressum = new Button("Impressum");
        Button btnContact = new Button("Kontakt");

        btnImpressum.setStyleName(BaseTheme.BUTTON_LINK);
        btnContact.setStyleName(BaseTheme.BUTTON_LINK);

        footerLayout.addComponent(btnImpressum);
        footerLayout.addComponent(btnContact);

        btnImpressum.addClickListener((Button.ClickEvent event) -> {
            UI.getCurrent().getNavigator().navigateTo(Views.IMPRESSUM);
        });
        btnContact.addClickListener((Button.ClickEvent event) -> {
            UI.getCurrent().getNavigator().navigateTo(Views.CONTACT);
        });
        footerLayout.setComponentAlignment(btnContact, Alignment.MIDDLE_CENTER);
        footerLayout.setComponentAlignment(btnImpressum, Alignment.MIDDLE_CENTER);

        footerLayout.setStyleName("customfooter");
        return footerLayout;
    }
}
