package org.s4s.modell.dto;

import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

/**
 *
 * @author Holger Karwanni
 */
public class Product {

    private String name;
    private String description;
    private double price;
    private Integer id;
    private String typ;
    private int shopId;

    public Product(String name, Integer id, String typ, double price, String description) {
        this.name = name;
        this.id = id;
        this.typ = typ;
        this.price = price;
        this.description = description;
    }

    public Product(String name, Integer id, String typ, double price, String description, int shopId) {
        this.name = name;
        this.id = id;
        this.typ = typ;
        this.price = price;
        this.description = description;
        this.shopId = shopId;
    }

    public Product() {

    }

    @Override
    public boolean equals(Object other) {
        if (other == null) {
            return false;
        }
        if (!(other instanceof Product)) {
            return false;
        }
        Product p = (Product) other;
        return new EqualsBuilder()
                .append(p.getName(), name)
                .append(p.getId(), id)
                .append(p.getTyp(), typ)
                .append(p.getPrice(), price)
                .append(p.getDescription(), description)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder()
                .append(name)
                .append(id)
                .append(typ)
                .append(price)
                .append(description)
                .hashCode();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getTyp() {
        return typ;
    }

    public void setTyp(String typ) {
        this.typ = typ;
    }

    public double getPrice() {
        return price;
    }

    public void setPrice(double price) {
        this.price = price;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public int getShopId() {
        return shopId;
    }

    public void setShopId(int shopId) {
        this.shopId = shopId;
    }
}
