package org.s4s.process.control;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import org.s4s.dao.ProductDAO;
import org.s4s.dao.impl.AbstractDatabaseClass;
import org.s4s.exceptions.DAOException;
import org.s4s.modell.dto.Product;
import org.s4s.modell.dto.Shop;

/**
 *
 * @author Holger
 */
public class ProductSearch extends AbstractDatabaseClass implements ProductDAO {

    private ProductSearch() {

    }

    public static ProductSearch search = null;

    public static ProductSearch getInstance() {
        if (search == null) {
            search = new ProductSearch();
        }
        return search;
    }

    @Override
    public List<Product> getProductByName(String kate) throws DAOException {
        List<Product> liste = new ArrayList<>();
        try (ResultSet set = executeQuery("SELECT *"
                + " FROM \"ERR\".\"artikel\" a"
                + " WHERE LOWER(a.name) ILIKE LOWER('%" + kate + "%');")) {
            while (set.next()) {
                String name = set.getString("name");
                int id = set.getInt("artikelID");
                String kategorie = set.getString("kategorie");
                double price = set.getDouble("preis");
                String description = set.getString("beschreibung");
                int shopId = set.getInt("shopid");

                Product p = new Product(name, id, kategorie, price, description, shopId);
                liste.add(p);
            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return liste;
    }

    @Override
    public List<Product> getProductByDescription(String descrip) throws DAOException {
        List<Product> liste = new ArrayList<>();
        try (ResultSet set = executeQuery("SELECT *"
                + " FROM \"ERR\".\"artikel\" a"
                + " WHERE LOWER(a.beschreibung) ILIKE LOWER('%" + descrip + "%');")) {
            while (set.next()) {
                String name = set.getString("name");
                int id = set.getInt("artikelid");
                String kategorie = set.getString("kategorie");
                double price = set.getDouble("preis");
                String description = set.getString("beschreibung");
                int shopId = set.getInt("shopid");

                Product p = new Product(name, id, kategorie, price, description, shopId);
                liste.add(p);
            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return liste;
    }

    @Override
    public Product getProductById(int id) throws DAOException {
        Product p = new Product();
        try (ResultSet set = executeQuery("SELECT *"
                + " FROM \"ERR\".\"artikel\" a"
                + " WHERE a.artikelid =  ('" + id + "');")) {
            if (set.next()) {
                String name = set.getString("name");
                int pId = set.getInt("artikelid");
                String kategorie = set.getString("kategorie");
                double price = set.getDouble("preis");
                String description = set.getString("beschreibung");
                int shopId = set.getInt("shopid");

                p.setName(name);
                p.setId(pId);
                p.setTyp(kategorie);
                p.setPrice(price);
                p.setDescription(description);
                p.setShopId(shopId);
            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return p;
    }

    @Override
    public Shop getProductOwner(Product product) throws DAOException {
        Shop s = new Shop();
        try (ResultSet set = executeQuery("SELECT *"
                + " FROM \"ERR\".\"shop\" s, \"ERR\".\"artikel\" a"
                + " WHERE s.shopid = a.shopid AND a.shopid = ('" + product.getShopId() + "');")) {
            if (set.next()) {
                int shopId = set.getInt("shopid");
                String name = set.getString("name");

                s.setShopId(shopId);
                s.setName(name);

            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return s;
    }
}
