package org.s4s.process.control;

import org.apache.commons.validator.routines.EmailValidator;
import org.s4s.dao.RegistrationDAO;
import org.s4s.exceptions.WrongInputException;

/**
 *
 * @author Simon
 */
public class RegistrationControl {

    //User-Block
    private static String email;
    private static RegistrationDAO regDAO = new RegistrationDAO();

    /**
     *
     * @param benutzer
     * @param nachname
     * @param vorname
     * @param gebDate
     * @param fBereich
     * @param email
     * @param emailwdh
     * @param passwort
     * @param passwortWdh
     */
    public static void init(String benutzer, String nachname, String vorname, java.util.Date gebDate, int fBereich, String email, String emailwdh, String passwort, String passwortWdh) {

        try {
            if (!passwort.equals(passwortWdh)) {
                throw new WrongInputException("Passwort entspricht nicht den Anforderungen!");
            }

            if (!email.equals(emailwdh) && !emailValidator()) {
                throw new WrongInputException("Email-Adressen stimmen nicht überein oder sind nicht gültig!");
            }
            if (!nameValidator(nachname)) {
                throw new WrongInputException("Nachname enthält ungültige Zeichen!");
            }

            if (!nameValidator(vorname)) {
                throw new WrongInputException("Vorname enthält ungültige Zeichen!");
            }

            if (!passwordValidator(passwort)) {
                throw new WrongInputException("Passwort ungültig!");
            }
        } catch (WrongInputException w) {
            w.printStackTrace();
            System.out.println("Exception occur: " + w.getMessage());
        }
        regDAO.addUser(regDAO.getUserID(), benutzer, nachname, vorname, gebDate, fBereich, email, emailwdh, passwort, passwortWdh);
    }

    public static boolean nameValidator(String toValidate) {
        //wenn Eingabe falsch -> Notification

        for (int i = 0; i < toValidate.length(); ++i) {
            if (!Character.isLetter(toValidate.charAt(i))) {
                return false;
            }
        }
        return true;
    }

    public static boolean emailValidator() {
        return EmailValidator.getInstance().isValid(email);
    }

    public static boolean passwordValidator(String passwort) {

        return passwort.length() > 8;
        /* String regex = "^.*(?=.{8,})(?=..*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[!@#$%^&+=]).*$";
        Pattern p = Pattern.compile(regex);
        Matcher m = p.matcher(passwort);
        return m.matches(); */
    }

}
