package org.s4s.process.control;

import com.vaadin.server.VaadinSession;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.s4s.dao.ShopDAO;
import org.s4s.dao.impl.AbstractDatabaseClass;
import org.s4s.exceptions.OwnsAlreadyShop;
import org.s4s.modell.dto.User;
import org.s4s.services.db.JDBCConnection;
import org.s4s.services.util.Roles;

/**
 *
 * @author Benjamin
 */
public class ShopControl extends AbstractDatabaseClass implements ShopDAO {

    private static final User user = (User) VaadinSession.getCurrent().getAttribute(Roles.CURRENTUSER);
    private final Statement statement = JDBCConnection.getInstance().getStatement();

    //bekommt User aus der View Ã¼bergeben und prÃ¼ft ob dieser schon in der Shopdb vorhanden ist (= hat schon einen Shop).
    public static void checkUserShop(String shopName) throws OwnsAlreadyShop, SQLException {
        ShopControl sc = new ShopControl();
        boolean test = sc.viewShop(user);
        //Shop mit dem Nutzer schon vorhanden
        if (test == true) {
            throw new OwnsAlreadyShop("Sie besitzen bereits einen Shop!");
        } //noch kein Shop vorhanden
        else {
            addUserShop(shopName);
        }
    }

    private static void addUserShop(String shopName) throws SQLException {
        ShopControl sc = new ShopControl();
        boolean erstellung = sc.addShop(user, shopName);

        if (erstellung == false) {
            //Fehlerhandling
            throw new SQLException("Fehler beim Anlegen des Shops bitte noch einmal versuchen oder Programmierer kontaktieren!");
        }
    }

    //Shop anhand von User/Besitzer auslesen
    /**
     *
     * @param user
     * @return
     */
    @Override
    public boolean viewShop(User user) {
        boolean result = false;
        try {
            ResultSet set = executeQuery("SELECT \"besitzer\""
                    + "FROM \"ERR\".\"shop\" "
                    + "WHERE besitzer = " + user.getUserId() + ";");

            if (set.next()) {
                result = true;
            }
        } catch (SQLException ex) {
            Logger.getLogger(ShopDAO.class.getName()).log(Level.SEVERE, null, ex);
        }
        return result;
    }

    /**
     *
     * @param user
     * @param shopName
     * @return
     */
    @Override
    public boolean addShop(User user, String shopName) {
        //Shop via Benutzername anlegen da dieser idR eindeutig ist
        try {
            // vorausgesetzt ID wird automatisch gesetzt von der DB
            statement.execute("INSERT INTO \"ERR\".\"shop\" (name, besitzer) VALUES ("
                    + "'" + shopName + "'" + ","
                    + user.getUserId() + ");"); // + ","
            //+ shopDescription + ");");
            return true;
        } catch (SQLException ex) {
            Logger.getLogger(ShopDAO.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }

    }
}
