package org.s4s.process.control;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import org.s4s.dao.ShopSearchDAO;
import org.s4s.dao.impl.AbstractDatabaseClass;
import org.s4s.exceptions.DAOException;
import org.s4s.modell.dto.Shop;

/**
 *
 * @author Holger
 */
public class ShopSearch extends AbstractDatabaseClass implements ShopSearchDAO {

    private ShopSearch() {

    }

    public static ShopSearch search = null;

    public static ShopSearch getInstance() {
        if (search == null) {
            search = new ShopSearch();
        }
        return search;
    }

    @Override
    public List<Shop> getShopByName(String typ) throws DAOException {
        List<Shop> liste = new ArrayList<>();

        try (ResultSet set = executeQuery("SELECT *"
                + " FROM \"ERR\".\"shop\" s"
                + " WHERE LOWER(s.name) = LOWER('" + typ + "');")) {
            while (set.next()) {
                int shopId = set.getInt("shopid");
                String name = set.getString("name");
                int besitzer = set.getInt("besitzer");
                double bewertung = set.getDouble("bewertung");
                int bewertunganzahl = set.getInt("bewertungsanzahl");

                Shop s = new Shop(shopId, name, besitzer, bewertung, bewertunganzahl);
                liste.add(s);
            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return liste;
    }

    @Override
    public List<Shop> getShopByOwner(String typ) throws DAOException {
        List<Shop> liste = new ArrayList<>();

        try (ResultSet set = executeQuery("SELECT *"
                + " FROM \"ERR\".\"shop\" s"
                + " WHERE LOWER(s.besitzer) = LOWER('" + typ + "');")) {
            while (set.next()) {
                int shopId = set.getInt("shopid");
                String name = set.getString("name");
                int besitzer = set.getInt("besitzer");
                double bewertung = set.getDouble("bewertung");
                int bewertunganzahl = set.getInt("bewertungsanzahl");

                Shop s = new Shop(shopId, name, besitzer, bewertung, bewertunganzahl);
                liste.add(s);
            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return liste;
    }

}
