package org.s4s.process.control;

import com.vaadin.ui.UI;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import org.s4s.dao.impl.AbstractDatabaseClass;
import org.s4s.exceptions.DAOException;
import org.s4s.modell.dto.Product;
import org.s4s.modell.dto.Transaction;
import org.s4s.modell.dto.User;
import org.s4s.modell.dto.Warenkorb;
import org.s4s.services.db.JDBCConnection;
import org.s4s.services.util.Roles;

/**
 *
 * @author Sebastian
 */
public class TransactionControl extends AbstractDatabaseClass {

    private final Transaction transaktion = new Transaction();
    private final Statement statement = JDBCConnection.getInstance().getStatement();

    //String kaeuferString = (String) UI.getCurrent().getSession().getAttribute(Roles.CURRENTUSER);
    public void createTransactions() throws DAOException, SQLException {
        User u = (User) UI.getCurrent().getSession().getAttribute(Roles.CURRENTUSER);
        String name = u.getBenutzername();
        int id = u.getUserId();
        User user = new User(name, id);
        transaktion.setKaeufer(user);
        for (Product p : Warenkorb.getInstance().inhalt()) {
            transaktion.setVerkaeufer(kaeuferinDB(p.getId()));
            transaktion.setProdukt(p);
            createTransactionInDB(transaktion);
            updateGekauftStatusInArtikel(transaktion);
        }
    }

    public Integer kaeuferinDB(int produktid) throws DAOException, SQLException {
        Integer verkaeufer;
        try (ResultSet rs = executeQuery("SELECT u.\"besitzer\"" + " FROM \"ERR\".\"shop\" u , \"ERR\".\"artikel\" s"
                + " WHERE u.shopid = s.shopid AND "
                + "s.artikelid = '" + transaktion.getProdukt().getId() + "';");) {

            verkaeufer = rs.getInt("besitzer");
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return verkaeufer;
    }

    public void createTransactionInDB(Transaction transaktion) throws DAOException, SQLException {
        try {
            statement.execute("INSERT INTO \"ERR\".\"transaktion\" (verkaeufer, kaeufer, artikelid) VALUES("
                    + transaktion.getVerkaeufer() + ","
                    + transaktion.getKaeufer().getUserId() + ","
                    + transaktion.getProdukt().getId());
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
    }

    public void updateGekauftStatusInArtikel(Transaction transaktion) throws DAOException, SQLException {
        try {
            statement.execute("UPDATE INTO \"ERR\".\"artikel\""
                    + "SET gekauft = true"
                    + "WHERE artikelid = "
                    + transaktion.getProdukt().getId());
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
    }

}
