package org.s4s.dao.impl;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.s4s.dao.RegistrationDAO;
import org.s4s.exceptions.WrongInputException;
import org.s4s.modell.dto.User;
import org.s4s.process.control.RegistrationControl;
import org.s4s.services.db.JDBCConnection;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Date;

/**
 * Created by uerdingen on 03.06.17.
 */
public class RegistrationControl_Test {

    private User user = null;

    @Test
    public void nameValidator_Test() {
        assertTrue(RegistrationControl.nameValidator("Uerdingen"));
        assertFalse(RegistrationControl.nameValidator("fs2df3"));
        
    }

    @Before
    public void init(){
        Date bday = new Date();
        bday.setYear(1995);
        bday.setMonth(5);
        bday.setDate(15);

        RegistrationDAO regDAO = new RegistrationDAO();
        int userID = regDAO.getUserID();
        RegistrationControl.init("Testcase", "Nachname", "Tester", bday, 2, "testmail@gmx.de", "testmail@gmx.de", "test12345", "test12345");

        user = new User("Testcase", userID);
        user.setEmail("testmail@gmx.de");
        user.setFachbereichId(2);
        user.setGeburtsdatum("1995-5-15");
        user.setNachname("Nachname");
        user.setVorname("Tester");
    }

    @Test
    public void Registration_Test() {

        String sql_query = "SELECT *" + " FROM \"ERR\".\"user\" u " + " WHERE u.benutzername = '" + "Testcase" +"';";
        // String sql_query = "SELECT * FROM \"ERR\".\"user\" u WHERE u.benutzername = 'Testcase'";
        try {
            ResultSet set = JDBCConnection.getInstance().getStatement().executeQuery(sql_query);
            if(!set.next()){
                throw new WrongInputException("Wrong Input");
            }
            assertEquals(user.getBenutzername(),set.getString("benutzername"));
            assertEquals(user.getVorname(),set.getString("vorname"));
            assertEquals(user.getNachname(),set.getString("nachname"));
            assertEquals(user.getFachbereichId(),set.getInt("fachbreichid"));
           assertEquals(user.getEmail(),set.getString("email"));
           assertEquals(user.getUserId(),set.getInt("userID"));
        } catch (Exception e) {
            e.printStackTrace();
        }


    }

    @After
    public void delete(){
        String sql_delete = "DELETE FROM \"ERR\".\"user\" u "+ " WHERE u.benutzername = '" + "Testcase" +"';";
        try {
            int exe = JDBCConnection.getInstance().getStatement().executeUpdate(sql_delete);
            if(exe<0){
                throw new WrongInputException("Wrong input");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
