/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.s4s.modell.dto;


import org.junit.Assert;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import org.junit.Before;
import org.junit.Test;
import org.s4s.modell.dto.Product;
import org.s4s.modell.dto.Warenkorb;

/**
 *
 * @author Holger
 */
public class WarenkorbTest {
    Product p1 = new Product();
    Product p2 = new Product();
    Product p3 = new Product();
    Warenkorb warenkorb;
    
    @Before
    public void setUp(){        
        warenkorb = new Warenkorb();
        p1 = new Product("Glühbirne", 1, "Elektronik",1.50, "Halt ne Glühbirne");
        p2 = new Product("LED", 2, "Elektronik",7.99, "Halt ein LED");
        p3 = new Product("Neonröhre", 3, "Elektronik",19.95, "Halt ne Neonröhre");
    }
    @Test(expected = NullPointerException.class)
    public void test_add(){
        warenkorb.add(p1);
        assertTrue(warenkorb.contains(p1));
        warenkorb.add(p2);
        assertTrue(warenkorb.contains(p2));
        warenkorb.add(p3);
        assertTrue(warenkorb.contains(p3));
        warenkorb.add(null);

    }
    
    @Test(expected = NullPointerException.class)
    public void test_remove(){
        warenkorb.add(p1);
        warenkorb.remove(p1);
        assertFalse(warenkorb.contains(p1));
        warenkorb.remove(null);
    }
    
     @Test(expected = IllegalArgumentException.class)
     public void test_remove_notcontains(){
         warenkorb.remove(p1);
     
     }
    @Test
    public void test_sum(){    
        warenkorb.add(p1);
        assertEquals(1.50,warenkorb.sum(), 0.001);
        warenkorb.add(p2);
        assertEquals(9.49,warenkorb.sum(), 0.001);
        warenkorb.add(p3);
        assertEquals(29.44,warenkorb.sum(), 0.001);
    }

    @Test(expected = NullPointerException.class)
    public void test_contains(){
        warenkorb.contains(null);
    }
}
